module SingleRunner

  def report_block_result(test_code, wasp_id, time_ellapsed, benchmark_time, result, target_code)
    puts "BLOCK RESULT (#{test_code}): #{result}    Time: #{benchmark_time/1000} seconds  "
  end

  def time_ellapsed_millis
    return 0
  end

  def log
    logger = Logger.new(STDERR)
    return logger
  end

  def error_count
    return @error_count
  end

  def run_and_benchmark(test, target, params, iterations)
    load_node = LoadNode.instance
    if (LoadNode.instance == nil)
      load_node = LoadNode.new(0, nil, nil)
    end
#    load_node.target_server = servers[target]

    @error_count = 0
    timings = []
    logger = Logger.new(STDERR)
    test.logger = logger
    test.owner = self
    test.params =  params
    test.set_up

    (1..iterations).each do |loop_index|
      puts "==============================================================="
      time = Benchmark.realtime {
        test.run
      }
      timings << time
      puts "=================> Iteration: #{test.class} #{loop_index}  Time: #{time} seconds"
    end
    test.tear_down
    return timings
  end
end
